# ---------------------------------------------------------------------- 
# Common build setup. 
#  
# Judith Katzy, Sebastian Johnert 16.10.2008
# ---------------------------------------------------------------------- 

# common headers
INCLUDEF    = -I$(FastJetdir)/include
INCLUDEH    = -I$(HepMCdir)/include -I$(CLHEPdir)/include -I$(ROOTSYS)/include 
#              -I$(HepPDTdir)/include -I$(ROOTSYS)/include
INCLUDES    = $(INCLUDEH) $(INCLUDEF)

ROOTGLIBS   = `root-config --glibs`
ROOTCFLAGS  = `root-config --cflags` -Wno-long-long

#CLHEP = -L$(CLHEPdir)/lib -lCLHEP    # causes problems in HepMCAnalysis_i interface!
CLHEPlib    = 

# common libraries
HepPDTlib   = 
#HepPDTlib   = -L$(HepPDTdir)/lib -lHepPDT -lHepPID
HepMClib    = $(HepMCdir)/lib/libHepMC.so $(HepMCdir)/lib/libHepMCfio.a
#FastJetlib  = -L$(FastJetdir)/lib -lfastjet -lSISConePlugin -lCDFConesPlugin -lsiscone -lsiscone_spherical
FastJetlib  = -L$(FastJetdir)/lib -lfastjet -lfastjetplugins -lsiscone -lsiscone_spherical

# output directories
BINDIR = bin
LIBDIR = lib

# C++/Fortran compiler and linker options
CXXFLAGS  = -pthread -pipe -ansi -fPIC -W -Wall -Wno-deprecated -Wno-empty-body 
FFLAGS    = -fno-second-underscore 

.SUFFIXES: .o .cc .f .exe

# compilation rules
.cc.o: $(INCLUDES) $<
	@echo "Compiling $<:"
	$(CXX) $(CXXFLAGS) $(INCLUDES) -c $< -o $@

.f.o: $<
	@echo "Compiling $<:"
	@$(F77) $(FFLAGS) $(INCLUDES) -c $< -o $@
