


/*! \mainpage HepMCAnalysis Tool 3.1
@author Cano Ay, Wolfgang Ehrenfeld, Sebastian Johnert, Judith Katzy, Zhonghua Qin
  
      October 2009
 *
 * \section intro_sec Introduction
 HepMCAnalyser is a tool for generator validation and comparisons.
The main idea is to have a stable, easy-to-use and extendable framework to
 provide a fast access point to generator level analysis.

A class library with benchmark physics processes has been written to analyse
 HepMC  generator output and fill root histogramms. The source code of the 
classes is in the HepMCAnalysis/include and src directories.


A web-interface is provided to display all or selected histogramms, compare
to references and validate the results based on Kolmogorov Tests. These 
scripts are in HepMCAnalysis/examples/macros


Steerable example programs can be used for event generation and conversion to
HepMC format. The steering it tuned to produce best agreement between the
  distributions of the different generators. The programms are in HepMCAnalysis/examples/generatorX where generatorX stands e.g. for pythia6, pythia8, herwigpp... .


  
 
  \section install_sec Installation
 
The tool is supported on the same platforms as the GENSER library. It links 
against the GENSER installation. It will automatically detect the CERN or the 
DESY mirror of the GENSER libraries.

For installation do the following:

1.: cd HepMCAnalysis

2.: source setup.sh         //setup the environment, link to genser libs

3.: make slib              // creates the shared lib of the analysis classes

   \section run_sec Running

For running go in the directory of the generator you want to check and 
perform the following steps:
 1.: cd examples/pythia6  //here we give the example for pythia, other generators follow the same schema

2.: make -f Makefile_pythia6 pythia6  // creates the pythia6 executable, see README for details

3.: ./pythia6.exe Process.Config     // generates pythia events and analyse them with class lib, write out histgramms in a root file

 */
