#include "alpgen_spec.h"

void fill_eweight(HepMC::GenEvent* evt)
{
  //fill some info into weights: 
  //int unwev; 
  //double maxwgt, avgwgt, errwgt, totlum;
  // evt->weights()["N_ev"]=ahwgts_.unwev;
  //evt->weights()["input_xs"]=ahwgts_.avgwgt;
  //evt->weights()["input_xs_error"]=ahwgts_.errwgt;
  evt->weights()["lumi"]=ahwgts_.totlum;
}

void fill_exsec(HepMC::GenEvent* evt)
{
  //needs HepMC 2.05.00 or greater; 
  //the x-section information can be filled in weights for earlier versions
  HepMC::GenCrossSection Hep_cross_section; 
  evstat_.nvpass=evstat_.nvcall-evstat_.nvfail;
  double meff_est=(evstat_.nvpass*1.)/evstat_.nvcall;
  //current estimation of the physical x-section:
  double phys_xsec=meff_est*ahwgts_.avgwgt;
  //error of the x-section estimation:
  //phys_xsec=ahwgts_.avgwgt*meff_est
  //error of the efficiency estimation
  double meff_est_err=sqrt(meff_est*(1-meff_est)/evstat_.nvcall);
  //add relative errors of eff. and input x-section in quadrature
  double mrelxs_est_err_2;
  if (meff_est==0.) mrelxs_est_err_2=99999.9;
  else mrelxs_est_err_2=std::min(((meff_est_err/meff_est)*(meff_est_err/meff_est)+(ahwgts_.errwgt/ahwgts_.avgwgt)*(ahwgts_.errwgt/ahwgts_.avgwgt)),99999.9);
  // fill x-section and the absolute error:
  Hep_cross_section.set_cross_section(phys_xsec,sqrt( mrelxs_est_err_2)*phys_xsec);
  evt->set_cross_section(Hep_cross_section);
  /*std::cout<<"debug : "<<std::endl;
  std::cout<<"nvpass, nvfail, nvcall"<<evstat_.nvpass<<" , "<<evstat_.nvcall<<" , "<<evstat_.nvfail<<std::endl;
  std::cout<<"meff_est, meff_est_err: "<<meff_est <<" , "<<meff_est_err<<std::endl;
  std::cout<<" ahwgts_.avgwgt : "<< ahwgts_.avgwgt<<std::endl;
  evt->write_cross_section();*/

}

