#ifndef ALPGEN_SPEC_H
#define ALPGEN_SPEC_H

#include "HepMC/GenEvent.h"
#include <iostream>
#include <fstream>
#include <cstdlib>
#include <vector>
#include <string>
#include <algorithm>
#include "HepMC/IO_HEPEVT.h"
#include "HepMC/IO_HERWIG.h"
#include "HepMC/IO_GenEvent.h"
#include "HepMC/IO_AsciiParticles.h"
#include "HepMC/GenEvent.h"

//________________________________________________________________________________________
// LM : add this for FastJet analysis
//----------------------------------------------------------------------------------------      
//#include "fastjet/ClusterSequence.hh"
//#include <fstream>
//----------------------------------------------------------------------------------------      
// end of LM : add this
//________________________________________________________________________________________

//alpgen-specific common blocks accessible by the user analysis routine:
extern "C" {
  //Michelangelo's monitoring common blocks
  /*C JETS FROM RADIATION OF LIGHT PARTONS:
C ISVETO=1 EVENT FAILS SINCE THERE ARE FEWER RECONSTRUCTED JETS THAN PARTONS
C     NJVETO=NUMBER OF RECONSTRUCTED JETS
C ISVETO=2 EVENT FAILS SINCE NOT ALL PARTONS MATCH A JET
C     NJVETO=NUMBER OF MATCHED PARTONS/JETS
C ISVETO=3 EVENT FAILS SINCE THERE ARE ADDITIONAL JETS
C     NJVETO= NUMBER OF JETS
C ISVETO=4 EVENT FAILS SINCE MATCHED JETS ARE NOT THE HARDEST (INCLUSIVE CASE)
C     NJVETO = HARDEST JET NOT MATCHED (1=HIGHEST ET, 2=2ND...*/
  extern struct{
    int iveto, isveto, njveto;
    }mtchstat_;
  //n.b. these are filled into HEPRUP
  //unwev : # of events in the input file
  //avgwgt=input xsection, errwgt=input x-sec. error, totlum=luminosity, 
  extern struct{
    double maxwgt, avgwgt, errwgt, totlum;
    int unwev; 
  }ahwgts_; 
  //needed since: alpgen end of LHEF file convention == NUP=0 
  extern struct {
    int NUP,IDPRUP,IDUP[500],ISTUP[500],MOTHUP[500][2],ICOLUP[500][2];
    double XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP[500][5],VTIMUP[500],SPINUP[500];
  } hepeup_;
  // # events passing UPVETO,  # of UPVETO calls,  # events failing UPVETO
  extern struct{
    int nvpass, nvcall,nvfail;
  }evstat_;
}

  // filling HepMC weight container
void fill_eweight(HepMC::GenEvent*);
void fill_exsec(HepMC::GenEvent*);

#endif
 
