#include <stdio.h>
#include <iostream>
#include <fstream>
#include <sstream>
#include "MyHerwigWrapper.h"

void readConfigFile( const std::string &configfile )
{
  using namespace std;

  string line;
  ifstream myfile (configfile.c_str());
  if (myfile.is_open())
    {
      // read line by line of the file
      while (! myfile.eof() )
	{
	  string myblock;
	  string myentry;
	  string mystr;
	  
	  // initialize values. Set to some unlike values.
	  int myint1=-9999;
	  int myint2=-9999;
	  int myint3=-9999;
	  int myint4=-9999;
	  int myint5=-9999;
	  
	  double myfl0=-9999.9;
	  double myfl1=-9999.9;
	  double myfl2=-9999.9;
	  double myfl3=-9999.9;
	  double myfl4=-9999.9;
	  
	  // write read lines into string line
	  getline (myfile,line);
	  
	  // now split the line into the subwords
	  // and write the substrings into vector
	  istringstream instring(line);
	  istringstream instring2(line);
	  istringstream instring3(line);
	  string temp;
	  
	  // fill the variables ... i like istringstream objects. Very convinient!
	  instring >> myblock >> myentry >> mystr;
	  instring2 >> temp >> temp >> myfl0 >>  myfl1 >> myfl2 >> myfl3 >> myfl4;
	  instring3 >> temp >> temp >> myint1 >> myint2 >> myint3 >> myint4 >> myint5;
	  
	  // check for Comments. If the line starts with # than skip the line
	  string::size_type pos = myblock.find("#");
	  if(pos != string::npos) continue;
	  // check for Comments. If the line starts with * than skip the line
	  string::size_type pos2 = myblock.find("*");
	  if(pos2 != string::npos) continue;
	  // check for Comments. If the line starts with '/' than skip the line
	  string::size_type pos3 = myblock.find("/");
	  if(pos3 != string::npos) continue;
	  
	  if(myblock.empty()) continue;
	  
	  // read hwproc entries
	  if (myblock == "hwproc") {
	    if((myentry == "pbeam1") && (myfl0!=-9999.9)){
	      hwproc.pbeam1=myfl0;
	      cout << "hwproc.pbeam1= " << hwproc.pbeam1 << endl;
	    }
	    else if((myentry == "pbeam2") && (myfl0!=-9999.9)){
	      hwproc.pbeam2=myfl0;
	      cout << "hwproc.pbeam2= " << hwproc.pbeam2 << endl;
	    }
	    else if((myentry == "iproc") && (myint1!=-9999)){
	      hwproc.iproc=myint1;
	      cout << "hwproc.iproc= " << hwproc.iproc << endl;
	    }
	    else {
	      cout << "Herwig:  block hwproc has pbeam1, pbeam2, iproc: YOU HAVE SPECIFIED "<< myentry <<endl;
	    }
	    
	  }
	  else if (myblock == "hwprop") {
	    if((myentry == "rmass") && (myint1!=-9999) && (myfl1!=-9999.9)){
	      hwprop.rmass[myint1]=myfl1;
	      cout << "hwprop.rmass[ "<<myint1<<"]=" << hwprop.rmass[myint1] << endl;
	    }
	    else {
	      cout << "Herwig:  block hwproc has rmass: YOU HAVE SPECIFIED "<< myentry <<endl;
	    }
	    
	  }
	  else if (myblock == "hwpram"){
	    if((myentry == "gamw") && (myfl0!=-9999.9) ){
	      hwpram.gamw=myfl0;
	      cout << "hwpram.gamw= " << hwpram.gamw << endl;
	    }      
	    else if((myentry == "gamz") && (myfl0!=-9999.9) ){
	      hwpram.gamz=myfl0;
	      cout << "hwpram.gamz= " << hwpram.gamz << endl;
	    }
	    else if((myentry == "modpdf") && (myint1!=-9999) ){
	      hwpram.modpdf[0]=myint1;
	      hwpram.modpdf[1]=myint1;
	      cout << "beam1:hwpram.modpdf= " << hwpram.modpdf[0] << endl;
	      cout << "beam2:hwpram.modpdf= " << hwpram.modpdf[1] << endl;
	    }
	    else if((myentry == "clpow") && (myfl0!=-9999.9) ){
	      hwpram.clpow=myfl0;
	      cout << "hwpram.clpow= " << hwpram.clpow << endl;
	    }                
	    else if((myentry == "prsof") && (myfl0!=-9999.9) ){
	      hwpram.prsof=myfl0;
	      cout << "hwpram.prsof= " << hwpram.prsof << endl;
	    }
	    else {
	      cout << "Herwig:  block hwpram has gamw, gamz, modpdf, clpow and prsof: YOU HAVE SPECIFIED "<< myentry <<endl;
	    }
	  }
	  else if (myblock == "hwprch") {
	    if(myentry == "autpdf") {
 	      string pdfsetName = mystr.c_str();
	      pdfsetName.copy(hwprch.autpdf[1-1],20);
	      pdfsetName.copy(hwprch.autpdf[2-1],20); 
	      cout << "beam1:hwprch.autpdf= " << hwprch.autpdf[1-1] << endl;
	      cout << "beam2:hwprch.autpdf= " << hwprch.autpdf[2-1] << endl;
	    }
	    else {
	      cout << "Herwig:  block hwprch has autpdf: YOU HAVE SPECIFIED "<< myentry <<endl;
	    }
	    
	  }
	  else if (myblock == "hwdist") {
	    if( (myentry == "pltcut") && (myfl0!=-9999.9)) {
	      hwdist.pltcut = myfl0;
	      cout << "hwdist.pltcut=" << hwdist.pltcut<< endl;
	    }
	    else if( (myentry == "mixing") && (myint1!=-9999)) {
	      hwdist.mixing = myint1;
	      cout << "hwdist.mixing=" << hwdist.mixing<< endl;
	    }
	    else {
	      cout << "Herwig:  block hwdist has pltcut and mixing: YOU HAVE SPECIFIED "<< myentry <<endl;
	    }
	  }
	  else if (myblock == "hwhard") {
	    if( (myentry == "ptmin") && (myfl0!=-9999.9)) {
	      hwhard.ptmin = myfl0;
	      cout << "hwhard.ptmin=" << hwhard.ptmin<< endl;
	    }
	    else {
	      cout << "Herwig:  block hwhard has ptmin: YOU HAVE SPECIFIED "<< myentry <<endl;
	    }
	    
	  }
	  else if (myblock == "jmparm") {
	    if( (myentry == "jmueo") && (myint1!=-9999)) {
	      jmparm.jmueo = myint1;
	      cout << "jmparm.jmueo=" << jmparm.jmueo<< endl;
	    }
	    else if( (myentry == "msflag") && (myint1!=-9999)) {
	      jmparm.msflag = myint1;
	      cout << "jmparm.msflag=" << jmparm.msflag<< endl;
	    }
	    else if( (myentry == "jmbug") && (myint1!=-9999)) {
	      jmparm.jmbug = myint1;
	      cout << "jmparm.jmbug=" << jmparm.jmbug<< endl;
	    }
	    else if( (myentry == "ptjim") && (myfl0!=-9999.9)) {
	      jmparm.ptjim = myfl0;
	      cout << "jmparm.ptjim=" << jmparm.ptjim<< endl;
	    }
	    else if( (myentry == "jmrad") && (myint1!=-9999) && (myfl1!=-9999.9)) {
	      jmparm.jmrad[myint1-1] = myfl1;
	      cout << "jmparm.jmrad["<<myint1-1<<"]="<< jmparm.jmrad[myint1-1]<< endl;
	    }
	    else {
	      cout << "Herwig:  block jmparm has jmueo, msflag, jubug, ptjim and jmrad: YOU HAVE SPECIFIED "<< myentry <<endl;
	    }
	  }
	  else if (myblock == "hwdspn") {
	    if(myentry == "taudec") {
	      string taudecay = mystr.c_str();
	      taudecay.copy(hwdspn.taudec,20);
	      cout << "hwdspn.taudec= " << hwdspn.taudec << endl;
	    }
	    else {
	      cout << "Herwig:  block hwdspn has taudec: YOU HAVE SPECIFIED "<< myentry <<endl;
	    }
	  }
	}
      myfile.close();
    }
  else cout << "Unable to open file";
};

