#!/usr/bin/python

# ---------------------------------------------------------------------- 
# 
# ---------------------------------------------------------------------- 

# ---------------------------------------------------------------------- 
def readPageTemplate( fileName ):
  file = open( fileName )
  fileCont = file.read()
  file.close()
  return fileCont

# ---------------------------------------------------------------------- 
def savePageTemplate( fileName, fileContent ):
  file = open( fileName, 'w+' )
  file.write( fileContent )
  file.close()

# ----------------------------------------------------------------------
# Creates index.html page
# ---------------------------------------------------------------------- 
def createIndexPage( sourceDir, destDir ):
  print '> generating index.html page...',
  #indexCont = readPageTemplate( sourceDir + '/templates/index.html' )

  # modify
  indexCont = """
  <html>
  <head>
    <title>Validation plots</title>
    <style type="text/css">
			@import "page_style.css";
    </style>
  </head>
  <frameset cols="370,*">
    <frame src="overview.html" name="overview">
  <frameset rows="180,*">
    <frame src="analysis.html" name="analysis">
    <frame src="empty.html" name="plots">
  <noframes>
    Ihr Browser kann keine Frames!
  </noframes>
  </frameset>
  </html>\n"""

  # save file 
  savePageTemplate( destDir + '/index.html', indexCont )
  print '  done!'

# ---------------------------------------------------------------------- 
# Creates overview.html page
# ---------------------------------------------------------------------- 
def createOverviewPage( sourceDir, destDir, images ):
  print '> generating overview.html page...',
  #overviewCont = readPageTemplate( sourceDir + '/templates/overview.html' )

  overviewCont = """
  <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
    <html xmlns="http://www.w3.org/1999/xhtml">
    <head>
    <style type="text/css">
    <!--
    body {position: absolute; background: white; margin: 0; padding: 0;}
    div#images {width: 130;}
    div#images a p img {height: 0; width: 0; border-width: 0;}
    div#images a:hover p img {position: fixed; top: 157px; left: 600px; height: 372px; width: 596px;}
    -->
    </style>
    <title>Plots in Directory </title>
    </head>
    <body>
    <a href="./.." target="_top">Parent Directory</a>
    <!--h1> <fonts style="position:fixed; top:0%%; left:45%%"> Validation plots </h1-->
    <div id="images"> """

  # modify template
  nImages = len( images ) 
  nCols = 2
  nRows = nImages / nCols
  if nImages % nCols != 0 or nRows == 0:
    nRows = nRows + 1
  cnt = 0
  
  print 'nCols:',nCols,', nRows:',nRows 
  cont = '<table>'
  for row in range( 0, nRows ):
    cont = cont + '<tr>'
    for col in range( 0, nCols ):
      cnt = cnt + 1
      if ( cnt <= nImages ):
        cont = cont + '<td>'
        cont = cont + '<a href = "./%s" target = "plots"><img src="%s" height=120 width=160></a>\n'
        cont = cont + '</td>'
        cont = cont % ( images[ cnt - 1 ], images[ cnt - 1 ] )
    cont = cont + '</tr>'
  cont = cont + '</table>'
 
  # update overview 
  overviewCont = overviewCont + cont
  
  overviewCont += '</div></body></html>'

  # save file 
  savePageTemplate( destDir + '/overview.html', overviewCont )
  print '  done!'

# ---------------------------------------------------------------------- 
# Creates empty.html page
# ---------------------------------------------------------------------- 
def createEmptyPage( sourceDir, destDir ):
  print '> generating empty.html page...',
  #emptyCont = readPageTemplate( sourceDir + '/templates/empty.html' )
  emptyCont = '<html>\n  <center> <pre> \n \n \n No histogram selected \n </pre>  </center> </html>'

  # modify

  # write file 
  savePageTemplate( destDir + '/empty.html', emptyCont )
  print '  done!'

# ---------------------------------------------------------------------- 
# Creates analysis.html page
# ---------------------------------------------------------------------- 
def createAnalysisPage( sourceDir, destDir, configuration, steering, sourceCode ):
#def createAnalysisPage( sourceDir, destDir, process, analysis, generator ):
  print '> generating analysis.html page...',
#  analysisCont = readPageTemplate( sourceDir + '/templates/analysis.html' )

  analysisCont = """
<html>
  <head>
    <title>Process and analysis</title>
    <style type="text/css">
			@import "page_style.css";
    </style>
  </head>
  <body>
  <h2> <fonts style="position:fixed; top:0%; left:45%"> Validation plots </h2> <br><br>
<p>&nbsp; For these plots the following setup was used:<br>
"""

  # modify
 
  #configuration = ''
  #steering = ''
  #sourceCode = srcCodeList[ analysis ]

  cont = '<ul>' 
  cont = cont + '<li> <a href="./%s" target="plots"> configuration </a> of the process (analysis kind, steering file, etc.) </li>' % configuration
  cont = cont + '<li> <a href="./%s" target="plots"> steering </a> of the generating process </li>' % steering
  cont = cont + '<li> <a href="./%s" target="plots"> source code </a> of the analysis </li>' % sourceCode
  cont = cont + '</ul>' 
  
  analysisCont = analysisCont + cont + '</p></body></html>' 
  
  # write file 
  savePageTemplate( destDir + '/analysis.html', analysisCont )
  print '  done!'

# ---------------------------------------------------------------------- 
# Display
# ---------------------------------------------------------------------- 
def createDisplayPage( sourceDir, destDir ):
  print '> generating display area...'
  displayCont = readPageTemplate( sourceDir + '/templates/display.html' )
  
  # modify
  displayCont = displayCont % cont

  # write file 
  savePageTemplate( destDir + '/display.html', displayCont )
  print '  done!'




