#include <stdio.h>
#include <iostream>
#include <fstream>
#include <sstream>
#include "HepMC/PythiaWrapper.h"
#include "CascadeWrapper.h"
#include "MyCascadeWrapper.h"

void readConfigFile( const std::string configfile )
{
  using namespace std;

  string line;
  ifstream myfile( configfile.c_str() );
  if ( myfile.is_open() ) {
	    // read line by line of the file
	    while (! myfile.eof() )
		{
		    string myblock;
		    string myentry;
		    string mystr;

		    // initialize values. Set to some unlike values.
		    int myint1=-9999;
		    int myint2=-9999;
		    int myint3=-9999;
		    int myint4=-9999;
		    int myint5=-9999;

		    double myfl1=-9999.9;
		    double myfl2=-9999.9;
		    double myfl3=-9999.9;
		    double myfl4=-9999.9;
		    double myfl5=-9999.9;

		    // write read lines into string line
		    getline (myfile,line);

		    // now split the line into the subwords
		    // and write the substrings into vector
		    std::istringstream instring(line);
		    std::istringstream instring2(line);
		    std::istringstream instring3(line);
		    std::string temp;

		    // fill the variables ... i like istringstream objects. Very convinient!
		    //instring >> myblock >> myentry >> mystr;
		    //instring2 >> temp >> temp >> myfl0 >>  myfl1 >> myfl2 >> myfl3 >> myfl4;
		    //instring3 >> temp >> temp >> myint1 >> myint2 >> myint3 >> myint4 >> myint5;
		    instring >> myblock >>myentry;
		    instring2 >> temp >> myfl1 >>  myfl2 >> myfl3 >> myfl4 >> myfl5;
		    instring3 >> temp >> myint1 >> myint2 >> myint3 >> myint4 >> myint5;

		    // check for Comments. If the line starts with # than skip the line
		    std::string::size_type pos = myblock.find("#");
		    if(pos != std::string::npos) continue;
		    // check for Comments. If the line starts with * than skip the line
		    std::string::size_type pos2 = myblock.find("*");
		    if(pos2 != std::string::npos) continue;
		    // check for Comments. If the line starts with '/' than skip the line
		    std::string::size_type pos3 = myblock.find("/");
		    if(pos3 != std::string::npos) continue;
		    // check for Comments. If the line starts with '!' than skip the line
		    std::string::size_type pos4 = myblock.find("!");
		    if(pos4 != std::string::npos) continue;

		    if(myblock.empty()) continue;

		    // This is just for debugging to see wether the variables are filled properly
		    //cout << myblock << " " << myentry << " " << mystr << std::endl;
		    //cout << myfl1 << " " << myfl2 << " " << myfl3 << " " << myfl4 << std::endl;
		    //cout << myint1 << " " << myint2 << " " << myint3 << " " << myint4 << " " << myint5 << std::endl;

		    if (myblock == "'PBE1'" && myfl3!=-9999.9) {
		      cainpu.plepin=myfl3;
		      std::cout << "'PBE1' = " << cainpu.plepin << std::endl;
		    }
		    else if (myblock == "'KBE1'" && myint3!=-9999) {
		      caluco.ke=myint3;
		      std::cout << "'KBE1' = " << caluco.ke << std::endl;
		    }
		    else if (myblock == "'IRE1'" && myint3!=-9999) {
		      capar6.ires[1-1]=myint3;
		      std::cout << "'IRE1' = " << capar6.ires[1-1] << std::endl;
		    }
		    else if (myblock == "'PBE2'" && myfl3!=-9999.9) {
		      cainpu.ppin=myfl3;
		      std::cout << "'PBE2' = " << cainpu.ppin << std::endl;
		    }
		    else if (myblock == "'KBE2'" && myint3!=-9999) {
		      caluco.kp=myint3;
		      std::cout << "'KBE2' = " << caluco.kp << std::endl;
		    }
		    else if (myblock == "'IRE2'" && myint3!=-9999) {
		      capar6.ires[2-1]=myint3;
		      std::cout << "'IRE2' = " << capar6.ires[2-1] << std::endl;
		    }
		    else if (myblock == "'QMIN'" && myfl3!=-9999.9) {
		      values.qmi=myfl3;
		      std::cout << "'QMIN' = " << values.qmi << std::endl;
		    }
		    else if (myblock == "'QMAX'" && myfl3!=-9999.9) {
		      values.qma=myfl3;
		      std::cout << "'QMAX' = " << values.qma << std::endl;
		    }
		    else if (myblock == "'YMIN'" && myfl3!=-9999.9) {
		      values.ymi=myfl3;
		      std::cout << "'YMIN' = " << values.ymi << std::endl;
		    }
		    else if (myblock == "'YMAX'" && myfl3!=-9999.9) {
		      values.yma=myfl3;
		      std::cout << "'YMAX' = " << values.yma << std::endl;
		    }
		    else if (myblock == "'THEI'" && myfl3!=-9999.9) {
		      caelec.themi=myfl3;
		      std::cout << "'THEI' = " << caelec.themi << std::endl;
		    }
		    else if (myblock == "'THEM'" && myfl3!=-9999.9) {
		      caelec.thema=myfl3;
		      std::cout << "'THEM' = " << caelec.thema << std::endl;
		    }
		    else if (myblock == "'NFLA'" && myint3!=-9999) {
		      caluco.nflav=myint3;
		      std::cout << "'NFLA' = " << caluco.nflav << std::endl;
		    }
		    else if (myblock == "'MULT'" && myint3!=-9999) {
		      camult.mult=myint3;
		      std::cout << "'MULT' = " << camult.mult << std::endl;
		    }
		    else if (myblock == "'IPRO'" && myint3!=-9999) {
		      capar1.ipro=myint3;
		      std::cout << "'IPRO' = " << capar1.ipro << std::endl;
		    }
		    else if (myblock == "'IHFL'" && myint3!=-9999) {
		      cahflav.ihfla=myint3;
		      std::cout << "'IHFL' = " << cahflav.ihfla << std::endl;
		    }
		    else if (myblock == "'PTCU'" && myfl3!=-9999.9) {
		      captcut.pt2cut[1-1]=myfl3;
		      std::cout << "'PTCU' = " << captcut.pt2cut[1-1] << std::endl;
		    }
		    else if (myblock == "'NFRA'" && myint3!=-9999) {
		      cainpu.nfrag=myint3;
		      std::cout << "'NFRA' = " << cainpu.nfrag << std::endl;
		    }
		    else if (myblock == "'IFPS'" && myint3!=-9999) {
		      cainpu.ifps=myint3;
		      std::cout << "'IFPS' = " << cainpu.ifps << std::endl;
		    }
		    else if (myblock == "'ITIM'" && myint3!=-9999) {
		      casshwr.itimshr=myint3;
		      std::cout << "'ITIM' = " << casshwr.itimshr << std::endl;
		    }
		    else if (myblock == "'ICCF'" && myint3!=-9999) {
		      casshwr.iccfm=myint3;
		      std::cout << "'ICCF' = " << casshwr.iccfm << std::endl;
		    }
		    else if (myblock == "'IRAM'" && myint3!=-9999) {
		      capar1.irunaem=myint3;
		      std::cout << "'IRAM' = " << capar1.irunaem << std::endl;
		    }
		    else if (myblock == "'IRAS'" && myint3!=-9999) {
		      capar1.iruna=myint3;
		      std::cout << "'IRAS' = " << capar1.iruna << std::endl;
		    }
		    else if (myblock == "'IQ2S'" && myint3!=-9999) {
		      capar1.iq2=myint3;
		      std::cout << "'IQ2S' = " << capar1.iq2 << std::endl;
		    }
		    else if (myblock == "'SCAL'" && myfl3!=-9999) {
		      scalf.scalfa=myfl3;
		      std::cout << "'SCAL' = " << scalf.scalfa << std::endl;
		    }
		    else if (myblock == "'IGLU'" && myint3!=-9999) {
		      cagluon.iglu=myint3;
		      std::cout << "'IGLU' = " << cagluon.iglu << std::endl;
		    }
		    else if (myblock == "'NCAL'" && myint3!=-9999) {
		      integr.ncb=myint3;
		      std::cout << "'NCAL' = " << integr.ncb << std::endl;
		    }
		    else if (myblock == "'ACC1'" && myfl3!=-9999.9) {
		      integr.acc1=myfl3;
		      std::cout << "'ACC1' = " << integr.acc1 << std::endl;
		    }
		    else if (myblock == "'ACC2'" && myfl3!=-9999.9) {
		      integr.acc2=myfl3;
		      std::cout << "'ACC2' = " << integr.acc2 << std::endl;
		    }
		    else if (myblock == "'INTE'" && myint3!=-9999) {
		      cainpu.inter=myint3;
		      std::cout << "'INTE' = " << cainpu.inter << std::endl;
		    }
		    //not sure if common blick is correct
		    else if (myblock == "'KT1'" && myfl3!=-9999.9) {
		      casprkt.prkt1=myfl3;
		      std::cout << "'KT1' = " << casprkt.prkt1 << std::endl;
		    }
		    //not sure if common blick is correct
		    else if (myblock == "'KT2'" && myfl3!=-9999.9) {
		      casprkt.prkt2=myfl3;
		      std::cout << "'KT2' = " << casprkt.prkt2 << std::endl;
		    }
		    //not sure if common blick is correct
		    else if (myblock == "'KTRE'" && myfl3!=-9999.9) {
		      casprkt.prktrem=myfl3;
		      std::cout << "'KTRE' = " << casprkt.prktrem << std::endl;
		    }
		    else if (myblock == "'ILHA'" && myint3!=-9999) {
		      caherup.ilha=myint3;
		      std::cout << "'ILHA' = " << caherup.ilha << std::endl;
		    }
		    //these commented lines has still to be set
		    //else if (myblock == "'UPDF'" && myentry.size()!=0) {
		    //std::cout<<"myentry = "<<myentry<<std::endl;
		    //caspdf.pdfpath=myentry.c_str();
		    //caspdf.pdfpath=myentry.c_str();
		    //std::cout << "'UPDF' = " << caspdf.pdfpath[myentry.size()-1] << std::endl;
		    //}
		    //this common block seems to be nowhere defined
		    //else if (myblock == "'GPYT'" && myint3!=-9999) {
		    //.=myint3;
		    //std::cout << "'GPYT' = " << . << std::endl;
		    //}
		    else if (myblock == "'PMAS'" && myint1!=-9999 && myint2!=-9999 && myfl3!=-9999.9) {
		      pydat2.pmas[myint2-1][myint1-1]=myfl3;
		      std::cout << "PMAS = pydat2.pmas[" << myint2<<"-1]["<< myint1 << "-1]=" << pydat2.pmas[myint2-1][myint1-1] << std::endl;
		    }
		    else if(myblock == "'PARU'" && myint1!=-9999 && myfl3!=-9999.9) {
		      std::cout<<"here"<<std::endl;
		      pydat1.paru[myint1-1]=myfl3;
		      std::cout << "PARU = pydat1.paru[" << myint1<<"-1]=" << pydat1.paru[myint1-1] << std::endl;
		    }
		    if((myblock == "'MSTU'") && (myint1!=-9999) && (myint3!=-9999)){
		      pydat1.mstu[myint1-1]=myint3;
		      std::cout << "MSTU = pydat1.mstu[" << myint1<<"-1]=" << pydat1.mstu[myint1-1] << std::endl;
		    }
		    else if((myblock == "'MSTJ'") && (myint1!=-9999) && (myint3!=-9999)){
		      pydat1.mstj[myint1-1]=myint3;
		      std::cout << "MSTJ = pydat1.mstj[" << myint1<<"-1]=" <<  pydat1.mstj[myint1-1] << std::endl;
		    }
		    else {
		      std::cout << "cascade:  available list: CAELEC, CAHERUP, CAHFLAV, CAINPU, CALUCO, CAMULT, CAPAR1, CAPAR6, CAPTCUT, CASPRKT, CASSHWR, INTEGR, VALUES, ... you have specified " << myblock << std::endl ;
		    }
		}
	    myfile.close();
	}
    else cout << "Unable to open file"; 
    
};

