#ifndef HERWIG_WRAPPER_H
#define HERWIG_WRAPPER_H

/* Common Block Declarations */
#include <complex>
#include <ctype.h>

const int m_nmxhep = 10000;

extern "C" {
extern struct {
    int ipart1, ipart2;
} hwbeam_;
}
#define hwbeam hwbeam_ 


extern "C" {
extern struct {
    char part1[8], part2[8];
} hwbmch_;
}
#define hwbmch hwbmch_

const int herwig_hepevt_size = 4000;

extern "C" {
extern struct {
    double ebeam1, ebeam2, pbeam1, pbeam2;
    int iproc, maxev;
} hwproc_;
}
#define hwproc hwproc_


extern "C" {
extern struct {
    double afch[32], alphem, b1lim, betaf, btclm, cafac,
	   cffac, clmax, clpow, clsmr[2], cspeed, ensof, etamix, f0mix, f1mix, 
	    f2mix, gamh, gamw, gamz, gamzp, gev2nb, h1mix, pdiqk, pgsmx, 
	  pgspl[4], phimix, pifac, prsof, psplt[2], ptrms, pxrms, qcdl3, qcdl5,
	     qcdlam, qdiqk, qfch[16], qg, qspac, qv, scabi, swein, tmtop, 
	    vfch[32], vckm[9], 
	    vgcut, vqcut, vpcut, zbinm,
            effmin, omhmix, et2mix, ph3mix, gcutme; 
    int ioprem, iprint, ispac, lrsud, lwsud, modpdf[2], nbtry, ncolo, 
	    nctry, ndtry, netry, nflav, ngspl, nstru, nstry, nzbin,
            iop4jt[2], nprfmt;
    int azsoft, azspin;
    int cldir[2];
    int hardme, nospac, prndec, prvtx, softme, zprime;
    int prndef, prntex, prnweb;
} hwpram_;
}
#define hwpram hwpram_

extern "C" {
extern struct {
    char autpdf[2][20], bdecay[4];
} hwprch_;
}
#define hwprch hwprch_


extern "C" {
extern struct {
    int nevpar, npar, istpar[500], idpar[500], jmopar[1000],
	    jdapar[1000];
    double ppar[2500], vpar[2000];
} hwpart_;
}
#define hwpart hwpart_ 


extern "C" {
extern struct {
    double decpar[1000], phipar[1000], rhopar[1000];
    int tmpar[500];
} hwparp_;
}
#define hwparp hwparp_

extern "C" {
extern struct {
  // rhohep = 3*NMXHEP
//   double alpfac, brhig[12], enhanc[12], gammax, rhohep[30000];
  double alpfac, brhig[12], enhanc[12], gammax, rhohep[3*m_nmxhep];
  int iophig, modbos[50];
} hwbosc_;
}
#define hwbosc hwbosc_

extern "C" {
extern struct {
    int jcopar[2000];
} hwparc_;
}
#define hwparc hwparc_

extern "C" {
extern struct {
    double anomsc[4], hardst, ptint[6], xfact;
    int inhad, jnhad, nspac[7], islent;
    int breit, frost, usecmf;
} hwbrch_;
}
#define hwbrch hwbrch_

extern "C" {
extern struct {
  // idhw = NMXHEP
    double avwgt, evwgt, gamwt, tlout, wbigst, wgtmax, wgtsum, wsqsum;
//     int idhw[10000], ierror, istat, lwevt, maxer, maxpr;
    int idhw[m_nmxhep], ierror, istat, lwevt, maxer, maxpr;
    bool nowgt;
    int nrn[2], numer, numeru, nwgts;
    int gensof;
} hwevnt_;
}
#define hwevnt hwevnt_


extern "C" {
extern struct {
    double asfixd, clq[42], coss, costh, ctmax, disf[26],
            emlst, emmax, emmin, empow, emsca, epoln[3],
	    gcoef[7], gpoln, omega0, phomas, ppoln[3], ptmax, ptmin, ptpow, 
      q2max, q2min, q2pow, q2wwmn, q2wwmx, qlim, sins, thmax, y4jt, tmnisr, 
	    tqwt, xx[2], xlmin, xxmin, ybmax, ybmin, yjmax, yjmin, ywwmax, 
	    ywwmin, whmin, zjmax, zmxisr;
    int iaphig, ibrn[2], ibsh, ico[10], idcmf, idn[10], iflmax, iflmin, 
	    ihpro, ipro, mapq[6], maxfl;
    int bgshat, colisr, fstevt, fstwgt, genev, hvfcen, tpol, durham;
} hwhard_;
}
#define hwhard hwhard_


extern "C" {
extern struct {
    double rltim[501], rmass[501], rspin[501];
    int ichrg[501], idpdg[501], iflav[501], nres;
    int vtocdk[501], vtordk[501];
    int qorqqb[501], qborqq[501];
} hwprop_;
}
#define hwprop hwprop_ 


extern "C" {
extern struct {
    char rname[4008];  /* 8*501 */
    char txname[37074];   /*  2*37*501  */
} hwunam_;
}
#define hwunam hwunam_


extern "C" {
extern struct {
    double brfrac[4000], cmmom[4000], dkltm[500];
    int idk[4000], idkprd[20000], lnext[4000], 
	    lstrt[500], ndkys, nme[4000], nmodes[500], nprods[4000];
    int dkpset, rstab[501];
} hwupdt_;
}
#define hwupdt hwupdt_


extern "C" {
extern struct {
    double repwt[100], sngwt, decwt, qwt[3], 
	    pwt[12], swtef[500];
} hwuwts_;
}
#define hwuwts hwuwts_


extern "C" {
extern struct {
    double cldkwt[4000], cthrpw[144], preco, 
	    resn[144], rmin[144];
    int locn[144], ncldk[4000], nreco;
    int clreco;
} hwuclu_;
}
#define hwuclu hwuclu_


extern "C" {
extern struct {
    double exag, gev2mm, hbar, pltcut, vmin2, vtxpip[5], xmix[2], xmrct[2]
	    , ymix[2], ymrct[2];
    int iopdkl;
    int maxdkl, mixing, pipsmr;
} hwdist_;
}
#define hwdist hwdist_


extern "C" {
extern struct {
    double vtxqdk[80];
    int imqdk[20], locq[20], nqdk;
} hwqdks_;
}
#define hwqdks hwqdks_


extern "C" {
extern struct {
    double accur, qev[6144], sud[6144];
    int inter, nqev, nsud, sudord;
} hwusud_;
}
#define hwusud hwusud_


extern "C" {
// v 6.1
extern struct {
    double tanb, alphah, cosbpa, sinbpa, cosbma, sinbma, cosa, sina,
          cosb, sinb, cotb, zmixss[16], zmxnss[16], zsgnss[4],
          lfch[16], rfch[16], slfch[64], srfch[64], wmxuss[4],
          wmxvss[4], wsgnss[2], qmixss[24], lmixss[24],
          thetat, thetab, thetal, atss, abss, alss, muss, factss,
          ghwwss[3], ghzzss[3], ghddss[4], ghuuss[4], ghwhss[3],
          ghsqss[96], xlmnss, rmmnss, dmssm, senhnc[24], ssparity;
    int susyin;
} hwsusy_;
}
#define hwsusy hwsusy_


extern "C" {
extern struct {
    double lamda1[27], lamda2[27], lamda3[27];
    int hrdcol[10];
    int rparty, colupd;
} hwrpar_;
}
#define hwrpar hwrpar_


extern "C" {
extern struct {
    double pmbn1, pmbn2, pmbn3, pmbk1, pmbk2, pmbm1, pmbm2,
          pmbp1, pmbp2, pmbp3;
} hwminb_;
}
#define hwminb hwminb_


extern "C" {
extern struct {
    double ppcl[2500];
    int idcl[500], ncl;
} hwclus_;
}
#define hwclus hwclus_

  // end v6.1 adds


extern "C" {
extern struct {
    double grvlam, emgrv, gamgrv;
} hwgrav_;
}
#define hwgrav hwgrav_


extern "C" {
extern struct {
    double vipwid[3], dxrcyl, dxzmax, dxrsph;
    int wzrfr, fix4jt;
    int imssm, ihiggs, parity, lrsusy;
} hw6202_;
}
#define hw6202 hw6202_
//end v 6202 adds

// v 6203


extern "C" {
extern struct {
    double abwgt, abwsum, avabw;
    int nnegwt, nnegev;
    int negwts;
} hw6203_;
}
#define hw6203 hw6203_

// begin v 6301 adds


extern "C" {
extern struct {
    double mjjmin, chnprb[20];
    int iopstp, iopsh;
    int  optm, chon[20];
} hw6300_;
}
#define hw6300 hw6300_


extern "C" {
extern struct {
    double fmrs[44688]	/* was [3][8][49][38] */;
} hwpmrs_;
}
#define hwpmrs hwpmrs_


extern "C" {
extern struct {
    int circop, circac, circvr, circrv, circch;
} hwcirc_;
}
#define hwcirc hwcirc_



//end v6301 adds

// v6.400


extern "C" {
extern struct {
    double abmode[100]	/* was [2][50] */, bbmode[1200]	/* was [2][12]
	    [50] */, pbmode[600]	/* was [12][50] */, wtbmax[600]	/* was [12][50] */;
    int idbprt[50], ibdrtp[50], ibmode[50], nbmode;
} hwdspb_;
}
#define hwdspb hwdspb_


extern "C" {
extern struct {
    double a2mode[1000]	/* was [2][500] */, p2mode[500], wt2max[500];
    int id2prt[500], i2drtp[500], n2mode;
} hwdsp2_;
}
#define hwdsp2 hwdsp2_


extern "C" {
extern struct {
    double a3mode[8000]	/* was [2][8][500] */, b3mode[8000]	/* was [2][8][500] */, p3mode[500], wt3max[500], spn3cf[4500]	/* was [3][3][500] */;
    int id3prt[500], i3mode[4000]	/* was [8][500] */, i3drtp[4000]	/* was [8][500] */, n3mode, ndi3by[500], n3ncfl[500], i3drcf[4000] /* was [8][500] */;
} hwdsp3_;
}
#define hwdsp3 hwdsp3_

extern "C" {
extern struct {
    double a4mode[96]	/* was [2][12][4] */, b4mode[96]	/* was [2][12][4] */, p4mode[576]	/* was [12][12][4] */, wt4max[576]	/* was [12][12][4] */;
    int id4prt[4], i4mode[8]	/* was [2][4] */, n4mode;
} hwdsp4_;
}
#define hwdsp4 hwdsp4_

extern "C" {
extern struct {
    int ndecsy, nsearch, lrdec, lwdec;
    int syspin, threeb, fourb;
    char taudec[6];
} hwdspn_;
}
#define hwdspn hwdspn_ 

extern "C" {
extern struct {
  // isnhep = NMXHEP
    std::complex<double> mespn[2400]	/* was [2][2][2][2][3][50] */, rhospn[200]	/* was [2][2][50] */;
    double spncfc[450]	/* was [3][3][50] */;
//     int idspn[50], jmospn[50], jdaspn[100]	/* was [2][50] */, nspn, isnhep[10000], nsntry;
    int idspn[50], jmospn[50], jdaspn[100]	/* was [2][50] */, nspn, isnhep[m_nmxhep], nsntry;
    int decspn[50];
    int ncfl[50], spcopt;
} hwspin_;
}
#define hwspin hwspin_

extern "C" {
extern struct {
    int jak1, jak2, itdkrc, ifphot;
} hwstau_;
}
#define hwstau hwstau_
//end v6400 adds


// v6500

extern "C" {
extern struct {
  double lhwgt[100], lhwgts[100], lhmxsm, lhxsct[100], lhxerr[100], lhxmax[100];
  int    lhiwgt[100], ityplh, lhnevt[100];
  int    lhsoft, lhglsf;
} hwgupr_;
}
#define hwgupr hwgupr_

extern "C" {
extern struct {
  int prespl;
} hw6500_;
}
#define hw6500 hw6500_
//end v6500 adds

// v6504

extern "C" {
extern struct {
  int itoprd;
} hw6504_;
}
#define hw6504 hw6504_
//end v6504 adds

// v6506

extern "C" {
extern struct {
  double pdfx0, pdfpow;
} hw6506_;
}
#define hw6506 hw6506_
//end v6506 adds

// v6506

extern "C" {
extern struct {
  int nedtry;
} hw6510_;
}
#define hw6510 hw6510_
//end v6510 adds

// Jimmy common blocks

extern "C" {
  extern struct {
    double ptjim, ygamma, jmzmin, jmrad[264], phad, jmu2, jmv2, jmarry[17][106], nlost, totscat;
    int anomoff, jcmvar, jmueo, jmptyp[117], jmbug, fn_type, msflag, maxmstry;
  } jmparm_;
}
#define jmparm jmparm_

#define jimmin jimmin_
#define jminit jminit_
#define hwmsct hwmsct_
extern "C" {
  void jimmin(void);
  void jminit(void); 
  void hwmsct(int *abort); 
}

// end Jimmy common blocks

// common for PDF information
extern "C" {
extern struct {
  double x1, x2, q;
  int id1, id2, idpdf1, idpdf2;
} hrwpdf_;
}
#define hrwpdf hrwpdf_

//extern "C" {
// extern struct {
//     int lhwout;
// } hwumsc_;
//}
//#define hwumsc hwumsc_

//--------------------------------------------------------------------------
// HERWIG routines declaration

#define hwigin hwigin_  // initialise other common blocks
#define hwigup hwigup_  // initialise HepUP run common block
#define hwuinc hwuinc_  // compute parameter-dependent constants
#define hwusta hwusta_  // call hwusta to make any particle stable
#define hweini hweini_  // initialise elementary process
#define hwuine hwuine_  // initialise event
#define hwepro hwepro_  // generate HERWIG hard subprocess
#define hwupro hwupro_  // read USER hard subprocess from HepUP event common
#define hwbgen hwbgen_  // generate parton cascades
#define hwdhob hwdhob_  // do heavy object decays
#define hwcfor hwcfor_  // do cluster hadronization
#define hwcdec hwcdec_  // do cluster decay
#define hwdhad hwdhad_  // do unstable particle decays
#define hwdhvy hwdhvy_  // do heavy flavour decays
#define hwmevt hwmevt_  // add soft underlying event if needed
#define hwufne hwufne_  // event generation completed, wrap up event ....
#define hwefin hwefin_  // terminate elementary process

#define hwudpr hwudpr_  // prints out particle/decay properties
#define hwuepr hwuepr_  // prints out event data
#define hwupup hwupup_  // prints out HepEUP user common block event data
#define hwegup hwegup_  // terminal calculations to replace HWEFIN for HepUP
    extern "C" {
        void hwigin(void);
        void hwigup(void);
        void hwuinc(void);
        void hwusta(const char*,int);
        void hweini(void);
        void hwuine(void);
        void hwepro(void);
        void hwupro(void);
        void hwbgen(void);
        void hwdhob(void);
        void hwcfor(void);
        void hwcdec(void);
        void hwdhad(void);
        void hwdhvy(void);
        void hwmevt(void);
        void hwufne(void);
        void hwefin(void);
        void hwudpr(void);
        void hwuepr(void);
        void hwupup(void);
        void hwegup(void);
    }

//--------------------------------------------------------------------------

//--------------------------------------------------------------------------
// HERWIG block data
// ( with gcc it works to initialize the block data by calling
//   "hwudat();" at beginning. )

#define hwudat hwudat_
extern "C" {
    void hwudat(void);
}

#endif  // HERWIG_WRAPPER_H
//--------------------------------------------------------------------------

