#include <stdio.h>
#include <iostream>
#include <fstream>
#include <sstream>
#include "HepMC/PythiaWrapper.h"
#include "MyPythia6Wrapper.h"

// ---------------------------------------------------------------------- 
void  readConfigFile( const std::string &configfile )
{
  using namespace std;

    string line;
    ifstream myfile (configfile.c_str());
    if (myfile.is_open())
	{
	    // read line by line of the file
	    while (! myfile.eof() )
		{
		    string myblock;
		    string myentry;
		    string mystr; 

		    // initialize values. Set to some unlike values.
		    int myint1=-9999;
		    int myint2=-9999;
		    int myint3=-9999;
		    int myint4=-9999;
		    int myint5=-9999;

		    double myfl0=-9999.9;
		    double myfl1=-9999.9;
		    double myfl2=-9999.9;
		    double myfl3=-9999.9;
		    double myfl4=-9999.9;

		    // write read lines into string line
		    getline (myfile,line);

		    // now split the line into the subwords
		    // and write the substrings into vector
		    std::istringstream instring(line);
		    std::istringstream instring2(line);
		    std::istringstream instring3(line);
		    std::string temp;

		    // fill the variables ... i like istringstream objects. Very convinient!
		    instring >> myblock >> myentry >> mystr;
		    instring2 >> temp >> temp >> myfl0 >>  myfl1 >> myfl2 >> myfl3 >> myfl4;
		    instring3 >> temp >> temp >> myint1 >> myint2 >> myint3 >> myint4 >> myint5;

		    // check for Comments. If the line starts with # than skip the line
		    std::string::size_type pos = myblock.find("#");
		    if(pos != std::string::npos) continue;
		    // check for Comments. If the line starts with * than skip the line
		    std::string::size_type pos2 = myblock.find("*");
		    if(pos2 != std::string::npos) continue;
		    // check for Comments. If the line starts with '/' than skip the line
		    std::string::size_type pos3 = myblock.find("/");
		    if(pos3 != std::string::npos) continue;

		    if(myblock.empty()) continue;

		    // This is just for debugging to see wether the variables are filled properly
		    //cout << myblock << " " << myentry << " " << mystr << std::endl;
		    //cout << myfl0 << " " << myfl1 << " " << myfl2 << " " << myfl3 << " " << myfl4 << std::endl;
		    //cout << myint1 << " " << myint2 << " " << myint3 << " " << myint4 << " " << myint5 << std::endl;

		    // read pysub entries
		    if (myblock == "pysubs") {
			if((myentry == "msel") && (myint1!=-9999)){
			    pysubs.msel=myint1;
			    std::cout << "pysubs.msel=" << pysubs.msel << std::endl;
			}
			else if ((myentry == "msub") && (myint1!=-9999) && (myint2!=-9999)){
			    pysubs.msub[myint1-1]=myint2;	 
			    std::cout << "pysubs.msub["<<myint1<<"-1]=" << pysubs.msub[myint1-1] << std::endl;
			}
			else if ((myentry == "ckin") && (myint1!=-9999) && (myfl1!=-9999.9)){
			    pysubs.ckin[myint1-1]=myfl1;	 
			    std::cout << "pysubs.ckin["<<myint1<<"-1]=" << pysubs.ckin[myint1-1] << std::endl;
			}
			else if ((myentry == "kfin") && (myint1!=-9999) && (myint2!=-9999) && (myint3!=-9999)){
			    pysubs.kfin[myint2-1][myint1-1]=myint3;	 
			    std::cout << "pysubs.kfin[" << myint2<<"-1]["<<myint1<<"-1]=" << pysubs.kfin[myint2-1][myint1-1] << std::endl;
			}
			else {
			    std::cout << "pythia6:  block PYSUBS has MSEL, MSUB, KFIN AND CKIN: YOU HAVE SPECIFIED "<< myentry <<std::endl;
			}
		    }
		    else if (myblock == "pypars"){
			if((myentry == "mstp") && (myint1!=-9999) && (myint2!=-9999)){
			    pypars.mstp[myint1-1]=myint2;
			    std::cout << "pypars.mstp[" << myint1<<"-1]=" << pypars.mstp[myint1-1] << std::endl;
			}
			else if((myentry == "msti") && (myint1!=-9999) && (myint2!=-9999)){
			    pypars.msti[myint1-1]=myint2;
			    std::cout << "pypars.msti[" << myint1<<"-1]=" << pypars.msti[myint1-1] << std::endl;
			}
			else if((myentry == "parp") && (myint1!=-9999) && (myfl1!=-9999.9)){
			    pypars.parp[myint1-1]=myfl1;
			    std::cout << "pypars.parp[" << myint1<<"-1]=" << pypars.parp[myint1-1] << std::endl;
			}
			else if((myentry == "pari") && (myint1!=-9999) && (myfl1!=-9999.9)){
			    pypars.pari[myint1-1]=myfl1;
			    std::cout << "pypars.parp[" << myint1<<"-1]=" << pypars.pari[myint1-1] << std::endl;
			}
			else {
			    std::cout << "pythia6:  block PYPARS has MSTP,PARP, MSTI AND PARI: YOU HAVE SPECIFIED "<< myentry <<std::endl;
			}
		    }
		    else if (myblock == "pydat1"){
			if((myentry == "mstu") && (myint1!=-9999) && (myint2!=-9999)){
			    pydat1.mstu[myint1-1]=myint2;
			    std::cout << "pydat1.mstu[" << myint1<<"-1]=" << pydat1.mstu[myint1-1] << std::endl;
			}       
			else if((myentry == "mstj") && (myint1!=-9999) && (myint2!=-9999)){
			    pydat1.mstj[myint1 - 1]=myint2;
			    std::cout << "pydat1.mstj[" << myint1<<"-1]=" <<  pydat1.mstj[myint1] << std::endl;
			}
			else if((myentry == "paru") && (myint1!=-9999) && (myfl1!=-9999.9)){
			    pydat1.paru[myint1-1]=myfl1;
			    std::cout << "pydat1.paru[" << myint1<<"-1]=" << pydat1.paru[myint1-1] << std::endl;
			}       
			else if((myentry == "parj") && (myint1!=-9999) && (myfl1!=-9999.9)){
			    pydat1.parj[myint1-1]=myfl1;
			    std::cout << "pydat1.parj[" << myint1<<"-1]=" << pydat1.parj[myint1-1] << std::endl;
			}
			else {
			    std::cout << "pythia6: block PYDAT1  HAS MSTU, MSTJ, PARU AND PARJ: YOU HAVE SPECIFIED "<< myentry << std::endl;
			}
		    }
		    else if (myblock == "pydat2"){
			if((myentry == "kchg") && (myint1!=-9999) && (myint2!=-9999) && (myint3!=-9999)){
			    pydat2.kchg[myint2-1][myint1-1]=myint3;
			    std::cout << "pydat2.kchg[" << myint2<<"-1]["<< myint1 << "-1]=" << pydat2.kchg[myint2-1][myint1-1] << std::endl;
			}       
			else if((myentry == "pmas") && (myint1!=-9999) && (myint2!=-9999) && (myfl2!=-9999.9)){
			    pydat2.pmas[myint2-1][myint1-1]=myfl2;
			    std::cout << "pydat2.pmas[" << myint2<<"-1]["<< myint1 << "-1]=" << pydat2.pmas[myint2-1][myint1-1] << std::endl;
			}
			else if((myentry == "parf") && (myint1!=-9999) && (myfl1!=-9999.9)){
			    pydat2.parf[myint1-1]=myfl1;
			    std::cout << "pydat2.parf[" << myint1<<"-1]=" << pydat2.parf[myint1-1] << std::endl;
			}       
			else if((myentry == "vckm") && (myint1!=-9999) && (myint2!=-9999) && (myfl2!=-9999.9)){
			    pydat2.vckm[myint2-1][myint1-1]=myfl2;
			    std::cout << "pydat2.vckm[" << myint2<<"-1]["<< myint1 << "-1]=" << pydat2.vckm[myint2-1][myint1-1] << std::endl;
			}
			else {
			    std::cout << "pythia6: block PYDAT2  HAS KCHG, PMAS, PARF AND VCKM: YOU HAVE SPECIFIED "<< myentry << std::endl;
			}
		    }
		    else if (myblock == "pydat3"){
			if((myentry == "mdcy") && (myint1!=-9999) && (myint2!=-9999) && (myint3!=-9999)){
			    pydat3.mdcy[myint2-1][myint1-1]=myint3;
			    std::cout << "pydat2.mdcy[" << myint2<<"-1]["<< myint1 << "-1]=" << pydat3.mdcy[myint2-1][myint1-1] << std::endl;
			}       
			else if((myentry == "mdme") && (myint1!=-9999) && (myint2!=-9999) && (myint3!=-9999)){
			    pydat3.mdme[myint2-1][myint1-1]=myint3;
			    std::cout << "pydat3.mdme[" << myint2<<"-1]["<< myint1 << "-1]=" << pydat3.mdme[myint2-1][myint1-1] << std::endl;
			}
			else if((myentry == "brat") && (myint1!=-9999) && (myfl1!=-9999.9)){
			    pydat3.brat[myint1-1]=myfl1;
			    std::cout << "pydat2.brat[" << myint1<<"-1]=" << pydat3.brat[myint1-1] << std::endl;
			}       
			else if((myentry == "kfdp") && (myint1!=-9999) && (myint2!=-9999) && (myint3!=-9999)){
			    pydat3.kfdp[myint2-1][myint1-1]=myint3;
			    std::cout << "pydat2.kfdp[" << myint2<<"-1]["<< myint1 << "-1]=" << pydat3.kfdp[myint2-1][myint1-1] << std::endl;
			}
			else {
			    std::cout << "pythia6:  block PYDAT3  HAS KFDP, MDCY, BRAT AND MDME : YOU HAVE SPECIFIED "<< myentry << std::endl ;
			}
		    }
		    else if (myblock == "pydatr"){
			if((myentry == "mrpy") && (myint1!=-9999) && (myint2!=-9999)){
			    pydatr.mrpy[myint1-1]=myint2;
			    std::cout << "pydatr.mrpy[" << myint1<<"-1]=" << pydatr.mrpy[myint1-1] << std::endl;
			}       
			else if((myentry == "rrpy") && (myint1!=-9999) && (myfl1!=-9999.9)){
			    pydatr.rrpy[myint1-1]=myfl1;
			    std::cout << "pydatr.rrpy[" << myint1<<"-1]=" << pydatr.rrpy[myint1-1] << std::endl;
			}
			else {
			    std::cout << "pythia6:  block PYDATR  HAS MRPY AND RRPY : YOU HAVE SPECIFIED "<< myentry << std::endl;
			}
		    }
		    else if (myblock == "pyint2"){
			if ((myentry == "iset") && (myint1!=-9999) && (myint2!=-9999)){
			    pyint2.iset[myint1-1]=myint2; 
			    std::cout << "pyint2.iset[" << myint1<<"-1]=" << pyint2.iset[myint1-1] << std::endl;
			}
			else if ((myentry == "kfpr") && (myint1!=-9999) && (myint2!=-9999) && (myint3!=-9999)){
			    pyint2.kfpr[myint2-1][myint1-1]=myint3;  
			    std::cout << "pyint2.kfpr[" << myint2<<"-1][" << myint1<< "-1]=" << pyint2.kfpr[myint2-1][myint1-1] << std::endl;
			}
			else if ((myentry == "coef") && (myint1!=-9999) && (myint2!=-9999) && (myfl2!=-9999.9)){
			    pyint2.coef[myint2-1][myint1-1]=myfl2;  
			    std::cout << "pyint2.coef[" << myint2<<"-1][" << myint1<< "-1]=" << pyint2.coef[myint2-1][myint1-1] << std::endl;
			}
			else if ((myentry == "icol") && (myint1!=-9999) && (myint2!=-9999) && (myint3!=-9999) && (myint4!=-9999)){
			    pyint2.icol[myint3-1][myint2-1][myint1-1]=myint4;  
			    std::cout << "pyint2.icol[" << myint3<<"-1][" << myint2<< "-1]["<< myint1<< "-1]=" << pyint2.icol[myint3-1][myint2-1][myint1-1] << std::endl;
			}
			else {
			    std::cout  << "pythia6:    block PYINT2 has ISET KFPR COEF AND ICOL: YOU HAVE SPECIFIED "<< myentry << std::endl;
			}
		    }
		    else if (myblock == "select"){
                        if ((myentry == "pytune") && (myint1!=-9999)){
			    pytune( &myint1 );
			    std::cout << "pytune("<< myint1<< ")" << std::endl;
                        }
                        else {
			    std::cout  << "pythia6:    block SELECT has PYTUNE: YOU HAVE SPECIFIED "<< myentry << std::endl;
                        }
                    }

		    else
			std::cout << "pythia6:  available list: PYSUBS, PYPARS, PYDAT1, PYDAT2, PYDAT3, PYDATR ... you have specified " << myblock << std::endl ;
		    
		}
	    myfile.close();
	}
    else cout << "Unable to open file"; 
    
};

