/**
  
*/

#include <iostream>

#include "HepMC/GenEvent.h"
#include "HepMC/IO_GenEvent.h"
#include "HepMC/GenParticle.h"
#include "HepMC/GenVertex.h"
#include "HepMC/IO_AsciiParticles.h"
#include "HepMC/SimpleVector.h"
#include "CLHEP/Vector/LorentzVector.h"

#include "TH1.h"
#include "TMath.h"
#include "TLorentzVector.h"

#include "fastjet/PseudoJet.hh"
#include "fastjet/ClusterSequence.hh"
#include "fastjet/JetDefinition.hh"
#include "fastjet/SISConePlugin.hh"

#include "../include/UserAnalysis.h"

// ---------------------------------------------------------------------- 
UserAnalysis::UserAnalysis()
{}

// ---------------------------------------------------------------------- 
UserAnalysis::~UserAnalysis()
{}

// ---------------------------------------------------------------------- 
int UserAnalysis::Init(double maxEta, double minPt)
{
  m_max_eta = maxEta;
  m_min_pt  = minPt;
  
  m_outputFileName = "UserAnalysis.root";
  m_outputRootDir  = "User";
 
  m_h_njets = initHist("njets", "N_jets", "Number of Jets", 15, 0.0, 15.0);

  return true; 
}

// ---------------------------------------------------------------------- 
int UserAnalysis::Process(HepMC::GenEvent* /*event*/)
{ 
  m_h_njets->Fill(m_inclusive_jets.size());
  
  return true;
}
 
